#!/usr/bin/tclsh

set greetingfile "greeting.txt"
set messagefile "message.txt"
set port 4000

proc readfile { name } {
    set sign ""
    if { [catch {open $name "r"} cin] } {
        puts $cin
        exit
    } else {
        while { [gets $cin line] != -1 } {
            lappend sign $line
        }
        close $cin
    }
    return $sign
}


proc connect { sock ip port } {

    global sign
    global credits

	puts "got connection from $ip $port"
    catch { puts $sock [join "$sign" "\n"] }
	flush $sock
	after 2000 "slowcat $sock 0"
	set cmd "catch {close $sock}"
	after 600000 $cmd
	return
}

proc slowcat { sock lineno } {
	global credits
	set line [lindex $credits $lineno]
	if { $lineno == [llength $credits] } {
		close $sock
		return
	}
	if { [ catch {puts $sock $line} ] } {
		return
	}
	catch {flush $sock}
	set cmd "slowcat $sock [incr lineno]"
	after 700 $cmd
	return
}

set sign [readfile $greetingfile]
set credits [readfile $messagefile]
socket -server connect $port
vwait forever
